org.apache.coyote.http11.upgrade

## Class AprServletOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - javax.servlet.ServletOutputStream
    - - org.apache.coyote.http11.upgrade.AbstractServletOutputStream
      - - org.apache.coyote.http11.upgrade.AprServletOutputStream

- All Implemented Interfaces:
    Closeable, Flushable, AutoCloseable

      public class AprServletOutputStream
      extends AbstractServletOutputStream

- - ### Field Summary

    - ### Fields inherited from class org.apache.coyote.http11.upgrade.AbstractServletOutputStream

      `sm`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AprServletOutputStream(SocketWrapper<Long> wrapper, int asyncWriteBufferSize, AprEndpoint endpoint)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `doClose()`
    `protected void` | `doFlush()`
    `protected int` | `doWrite(boolean block, byte[] b, int off, int len)` Abstract method to be overridden by concrete implementations.

    - ### Methods inherited from class org.apache.coyote.http11.upgrade.AbstractServletOutputStream

      `close, isCloseRequired, isReady, onError, onWritePossible, setWriteListener, write, write`

    - ### Methods inherited from class javax.servlet.ServletOutputStream

      `print, print, print, print, print, print, print, println, println, println, println, println, println, println, println`

    - ### Methods inherited from class java.io.OutputStream

      `flush, write`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AprServletOutputStream

          public AprServletOutputStream(SocketWrapper<Long> wrapper,
                                int asyncWriteBufferSize,
                                AprEndpoint endpoint)

  - ### Method Detail

    - #### doWrite

          protected int doWrite(boolean block,
                    byte[] b,
                    int off,
                    int len)
                         throws IOException

      Description copied from class: `AbstractServletOutputStream`
      Abstract method to be overridden by concrete implementations. The base class will ensure that there are no concurrent calls to this method for the same socket by ensuring that the writeLock is held when making any calls to this method.
      Specified by:
        `doWrite` in class `AbstractServletOutputStream`
      Throws:
        `IOException`

    - #### doFlush

          protected void doFlush()
                          throws IOException

      Specified by:
        `doFlush` in class `AbstractServletOutputStream`
      Throws:
        `IOException`

    - #### doClose

          protected void doClose()
                          throws IOException

      Specified by:
        `doClose` in class `AbstractServletOutputStream`
      Throws:
        `IOException`

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.